.MEM 8
.INDEX 8
.BASE $8000

new_reset:

-	lda $2002
	bpl -
--	lda $2002
	bpl --

; Load chr-rom bank #1 into VRAM
	lda #$01
	sta $8000

; Turn off screen
	lda #$00
	sta $2001
	jsr clear_screen

; Write palettes
	lda #$3F
	sta $2006
	lda #$00
	sta $2006	
	ldx #$00
-	lda pal_data,x
	sta $2007
	inx
	cpx #$10
	bne -

; Write atribute table data
	ldx #$40
	lda #$23
	sta $2006
	lda #$C0
	sta $2006
	lda #$00
-	sta $2007
	dex
	bne -
		

; Write our "text"
	lda #$20
	sta $2006
	lda #$82
	sta $2006
	ldx #$00
	lda str_press,x

; Convert ASCII to our font code
; 'A' = $41 (ASCII)
; 'A' = $0A (PROPIETARY)
	
-	sec
	sbc #$37
	sta $2007
	inx
	lda str_press,x
	bne -		; if 0, exit loop
	lda #$00
	sta $2005
	sta $2005

; Turn on screen
	lda #%00001010
	sta $2001
	lda #%00010000
	sta $2000

; Read key
get_key:	
	lda #$00
	sta $4016
	lda #$01
	sta $4016
	ldy #$08
-	lda $4016
	and #$01
	bne restore_gfx
	dey
	bne -
	jmp get_key

restore_gfx:
	lda #$00
	sta $2001 ; turn off screen
	lda #$00
	sta $8000 ; Load CHR-ROM bank 0
	jmp $c000 ; Go back to the original reset routine

str_press:
	.db "PRESS ANY BUTTON TO CONTINUE",0

pal_data:
	.db $02,$30,$30,$30
	.db $02,$30,$30,$30
	.db $02,$30,$30,$30
	.db $02,$30,$30,$30

; Clear screen
clear_screen:
	lda #$20
	sta $2006	
	lda #$00
	sta $2006
	ldy #$04
-	ldx #$FF
	lda #$ff
--	sta $2007
	dex
	bne --
	dey
	bne -
	rts

.END